'* WindowProcs.inc
'* Copyright (c) 2001 Sebastian Knig

DEF GetProcAddress(2) !"KERNEL32","GetProcAddress"
DEF GetModuleHandle(1) !"KERNEL32","GetModuleHandleA"

declare modName#,procName#,procAddress&

dim modName#,256
dim procName#,256

'FrameProc
'----------
'Callback-Funktion fr die Verwendung als Fenster-Prozedur fr
'das MDI FrameWindow (eigentlich immer das Hauptfenster des Pro-
'gramms).
'Die Nachricht WM_NCPAINT wird an DefFrameProc weitergeleitet.
'Alle anderen Nachrichten werden an die Original-Fenster-Prozedur
'weitergeleitet.

declare FrameProc#
dim FrameProc#,170
'push ebp
byte FrameProc#,0 = $55
'mov ebp,esp
byte FrameProc#,1 = $8B
byte FrameProc#,2 = $EC
'cmp dword ptr [ebp+0Ch],00000005h (WM_SIZE)
byte FrameProc#,3 = $81
byte FrameProc#,4 = $7D
byte FrameProc#,5 = $0C
long FrameProc#,6 = $00000005
'je FrameProc# + 100
byte FrameProc#,10 = $74
byte FrameProc#,11 = $58
'cmp dword ptr [ebp+0Ch],00000086h (WM_NCACTIVATE)
byte FrameProc#,12  = $81
byte FrameProc#,13 = $7D
byte FrameProc#,14 = $0C
long FrameProc#,15 = $00000086
'je FrameProc# + 69
byte FrameProc#,19 = $74
byte FrameProc#,20 = $30
'cmp dword ptr [ebp+0Ch],0000000Ch (WM_SETTEXT)
byte FrameProc#,21 = $81
byte FrameProc#,22 = $7D
byte FrameProc#,23 = $0C
long FrameProc#,24 = $0000000C
'je FrameProc# + 69
byte FrameProc#,28 = $74
byte FrameProc#,29 = $27

'---Start Original-Fensterprozedur aufrufen:
'mov edx,dword ptr [ebp+14h]
byte FrameProc#,30 = $8B
byte FrameProc#,31 = $55
byte FrameProc#,32 = $14
'push edx
byte FrameProc#,33 = $52
'mov eax,dword ptr [ebp+10h]
byte FrameProc#,34 = $8B
byte FrameProc#,35 = $45
byte FrameProc#,36 = $10
'push eax
byte FrameProc#,37 = $50
'mov ecx,dword ptr [ebp+0Ch]
byte FrameProc#,38 = $8B
byte FrameProc#,39 = $4D
byte FrameProc#,40 = $0C
'push ecx
byte FrameProc#,41 = $51
'mov edx,dword ptr [ebp+08h]
byte FrameProc#,42 = $8B
byte FrameProc#,43 = $55
byte FrameProc#,44 = $08
'push edx
byte FrameProc#,45 = $52
'push -00000015
byte FrameProc#,46 = $6A
byte FrameProc#,47 = $EB
'mov ecx,dword ptr [ebp+08h]
byte FrameProc#,48 = $8B
byte FrameProc#,49 = $4D
byte FrameProc#,50 = $08
'push ecx
byte FrameProc#,51 = $51
'mov edx,USER32.GetWindowLongA
string modName#,0 = "USER32"
string procName#,0 = "GetWindowLongA"
let procAddress& = GetProcAddress(GetModuleHandle(modName#),procName#)

byte FrameProc#,52 = $BA
long FrameProc#,53 = procAddress&
'call FAR edx
byte FrameProc#,57 = $FF
byte FrameProc#,58 = $D2
'push eax
byte FrameProc#,59 = $50
'mov edx,USER32.CallWindowProcA
string modName#,0 = "USER32"
string procName#,0 = "CallWindowProcA"
let procAddress& = GetProcAddress(GetModuleHandle(modName#),procName#)

byte FrameProc#,60 = $BA
long FrameProc#,61 = procAddress&
'call FAR edx
byte FrameProc#,65 = $FF
byte FrameProc#,66 = $D2
'---Ende Original-Fensterprozedur aufrufen.

'jmp FrameProc# + 166
byte FrameProc#,67 = $EB
byte FrameProc#,68 = $61

'---Start DefFrameProc aufrufen:
'mov ecx,dword ptr [ebp+14h]
byte FrameProc#,69 = $8B
byte FrameProc#,70 = $4D
byte FrameProc#,71 = $14
'push ecx
byte FrameProc#,72 = $51
'mov edx,dword ptr [ebp+10h]
byte FrameProc#,73 = $8B
byte FrameProc#,74 = $55
byte FrameProc#,75 = $10
'push edx
byte FrameProc#,76 = $52
'mov eax,dword ptr [ebp+0Ch]
byte FrameProc#,77 = $8B
byte FrameProc#,78 = $45
byte FrameProc#,79 = $0C
'push eax
byte FrameProc#,80 = $50
'mov edx,00000000h
byte FrameProc#,81 = $BA

'--An dieser Stelle steht spter das Handle des MDI-Clients:
long FrameProc#,82 = $00000000

'push edx
byte FrameProc#,86 = $52
'mov ecx,dword ptr [ebp+08h]
byte FrameProc#,87 = $8B
byte FrameProc#,88 = $4D
byte FrameProc#,89 = $08
'push ecx
byte FrameProc#,90 = $51
'mov edx,USER32.DefFrameProcA
string modName#,0 = "USER32"
string procName#,0 = "DefFrameProcA"
let procAddress& = GetProcAddress(GetModuleHandle(modName#),procName#)

byte FrameProc#,91 = $BA
long FrameProc#,92 = procAddress&
'call FAR edx
byte FrameProc#,96 = $FF
byte FrameProc#,97 = $D2
'---Ende DefFrameProc aufrufen.

'jmp FrameProc# + 166
byte FrameProc#,98 = $EB
byte FrameProc#,99 = $42

'---Start Original-Fensterprozedur und DefFrameProc aufrufen:
'mov edx,dword ptr [ebp+14h]
byte FrameProc#,100 = $8B
byte FrameProc#,101 = $55
byte FrameProc#,102 = $14
'push edx
byte FrameProc#,103 = $52
'mov eax,dword ptr [ebp+10h]
byte FrameProc#,104 = $8B
byte FrameProc#,105 = $45
byte FrameProc#,106 = $10
'push eax
byte FrameProc#,107 = $50
'mov ecx,dword ptr [ebp+0Ch]
byte FrameProc#,108 = $8B
byte FrameProc#,109 = $4D
byte FrameProc#,110 = $0C
'push ecx
byte FrameProc#,111 = $51
'mov edx,dword ptr [ebp+08h]
byte FrameProc#,112 = $8B
byte FrameProc#,113 = $55
byte FrameProc#,114 = $08
'push edx
byte FrameProc#,115 = $52
'push -00000015
byte FrameProc#,116 = $6A
byte FrameProc#,117 = $EB
'mov ecx,dword ptr [ebp+08h]
byte FrameProc#,118 = $8B
byte FrameProc#,119 = $4D
byte FrameProc#,120 = $08
'push ecx
byte FrameProc#,121 = $51
'mov edx,USER32.GetWindowLongA
string modName#,0 = "USER32"
string procName#,0 = "GetWindowLongA"
let procAddress& = GetProcAddress(GetModuleHandle(modName#),procName#)

byte FrameProc#,122 = $BA
long FrameProc#,123 = procAddress&
'call FAR edx
byte FrameProc#,127 = $FF
byte FrameProc#,128 = $D2
'push eax
byte FrameProc#,129 = $50
'mov edx,USER32.CallWindowProcA
string modName#,0 = "USER32"
string procName#,0 = "CallWindowProcA"
let procAddress& = GetProcAddress(GetModuleHandle(modName#),procName#)

byte FrameProc#,130 = $BA
long FrameProc#,131 = procAddress&
'call FAR edx
byte FrameProc#,135 = $FF
byte FrameProc#,136 = $D2
'-------------------------------
'mov ecx,dword ptr [ebp+14h]
byte FrameProc#,137 = $8B
byte FrameProc#,138 = $4D
byte FrameProc#,139 = $14
'push ecx
byte FrameProc#,140 = $51
'mov edx,dword ptr [ebp+10h]
byte FrameProc#,141 = $8B
byte FrameProc#,142 = $55
byte FrameProc#,143 = $10
'push edx
byte FrameProc#,144 = $52
'mov eax,dword ptr [ebp+0Ch]
byte FrameProc#,145 = $8B
byte FrameProc#,146 = $45
byte FrameProc#,147 = $0C
'push eax
byte FrameProc#,148 = $50
'mov edx,00000000h
byte FrameProc#,149 = $BA

'--An dieser Stelle steht spter das Handle des MDI-Clients:
long FrameProc#,150 = $00000000

'push edx
byte FrameProc#,154 = $52
'mov ecx,dword ptr [ebp+08h]
byte FrameProc#,155 = $8B
byte FrameProc#,156 = $4D
byte FrameProc#,157 = $08
'push ecx
byte FrameProc#,158 = $51
'mov edx,USER32.DefFrameProcA
string modName#,0 = "USER32"
string procName#,0 = "DefFrameProcA"
let procAddress& = GetProcAddress(GetModuleHandle(modName#),procName#)

byte FrameProc#,159 = $BA
long FrameProc#,160 = procAddress&
'call FAR edx
byte FrameProc#,164 = $FF
byte FrameProc#,165 = $D2
'---Ende Original-Fensterprozedur und DefFrameProc aufrufen.

'pop ebp
byte FrameProc#,166 = $5D
'ret 10h
byte FrameProc#,167 = $C2
byte FrameProc#,168 = $10
byte FrameProc#,169 = $00


'MDIChildProc
'-------------
'Callback-Funktion fr die Verwendung als Fenster-Prozedur fr
'die MDI Child-Fenster.
'Einige Nachrichten werden an DefMDIChildProc weitergeleitet.
'Die Nachrichten WM_MOVE und WM_SIZE werden sowohl an die ur-
'sprngliche Fenster-Prozedur, als auch an DefMDIChildProc
'weitergeleitet.
'Alle anderen Nachrichten werden an die ursprngliche Fenster-
'Prozedur weitergeleitet.

declare MDIChildProc#
dim MDIChildProc#,260
'push ebp
byte MDIChildProc#,0 = $55
'mov ebp,esp
byte MDIChildProc#,1 = $8B
byte MDIChildProc#,2 = $EC

'cmp dword ptr [ebp+0Ch],00000085h (WM_NCPAINT)
byte MDIChildProc#,3 = $81
byte MDIChildProc#,4 = $7D
byte MDIChildProc#,5 = $0C
long MDIChildProc#,6 = $00000085
'je MDIChildProc# + 171
byte MDIChildProc#,10 = $0F
byte MDIChildProc#,11 = $84
long MDIChildProc#,12 = $0000009B
'cmp dword ptr [ebp+0Ch],00000084h (WM_NCHITTEST)
byte MDIChildProc#,16 = $81
byte MDIChildProc#,17 = $7D
byte MDIChildProc#,18 = $0C
long MDIChildProc#,19 = $00000084
'je MDIChildProc# + 171
byte MDIChildProc#,23 = $0F
byte MDIChildProc#,24 = $84
long MDIChildProc#,25 = $0000008E
'cmp dword ptr [ebp+0Ch],00000083h (WM_NCCALCSIZE)
byte MDIChildProc#,29 = $81
byte MDIChildProc#,30 = $7D
byte MDIChildProc#,31 = $0C
long MDIChildProc#,32 = $00000083
'je MDIChildProc# + 171
byte MDIChildProc#,36 = $0F
byte MDIChildProc#,37 = $84
long MDIChildProc#,38 = $00000081
'cmp dword ptr [ebp+0Ch],00000007h (WM_SETFOCUS)
byte MDIChildProc#,42 = $81
byte MDIChildProc#,43 = $7D
byte MDIChildProc#,44 = $0C
long MDIChildProc#,45 = $00000007
'je MDIChildProc# + 171
byte MDIChildProc#,49 = $74
byte MDIChildProc#,50 = $78
'cmp dword ptr [ebp+0Ch],00000112h (WM_SYSCOMMAND)
byte MDIChildProc#,51 = $81
byte MDIChildProc#,52 = $7D
byte MDIChildProc#,53 = $0C
long MDIChildProc#,54 = $00000112
'je MDIChildProc# + 171
byte MDIChildProc#,58 = $74
byte MDIChildProc#,59 = $6F
'cmp dword ptr [ebp+0Ch],00000024h (WM_GETMINMAXINFO)
byte MDIChildProc#,60 = $81
byte MDIChildProc#,61 = $7D
byte MDIChildProc#,62 = $0C
long MDIChildProc#,63 = $00000024
'je MDIChildProc# + 171
byte MDIChildProc#,67 = $74
byte MDIChildProc#,68 = $66
'cmp dword ptr [ebp+0Ch],00000120h (WM_MENUCHAR)
byte MDIChildProc#,69 = $81
byte MDIChildProc#,70 = $7D
byte MDIChildProc#,71 = $0C
long MDIChildProc#,72 = $00000120
'je MDIChildProc# + 171
byte MDIChildProc#,76 = $74
byte MDIChildProc#,77 = $5D
'cmp dword ptr [ebp+0Ch],00000022h (WM_CHILDACTIVATE)
byte MDIChildProc#,78 = $81
byte MDIChildProc#,79 = $7D
byte MDIChildProc#,80 = $0C
long MDIChildProc#,81 = $00000022
'je MDIChildProc# + 171
byte MDIChildProc#,85 = $74
byte MDIChildProc#,86 = $54
'cmp dword ptr [ebp+0Ch],00000086h (WM_NCACTIVATE)
byte MDIChildProc#,87 = $81
byte MDIChildProc#,88 = $7D
byte MDIChildProc#,89 = $0C
long MDIChildProc#,90 = $00000086
'je MDIChildProc# + 171
byte MDIChildProc#,94 = $74
byte MDIChildProc#,95 = $4B
'cmp dword ptr [ebp+0Ch],0000000Ch (WM_SETTEXT)
byte MDIChildProc#,96 = $81
byte MDIChildProc#,97 = $7D
byte MDIChildProc#,98 = $0C
long MDIChildProc#,99 = $0000000C
'je MDIChildProc# + 171
byte MDIChildProc#,103 = $74
byte MDIChildProc#,104 = $42
'cmp dword ptr [ebp+0Ch],00000082h (WM_NCDESTROY)
byte MDIChildProc#,105 = $81
byte MDIChildProc#,106 = $7D
byte MDIChildProc#,107 = $0C
long MDIChildProc#,108 = $00000082
'je MDIChildProc# + 171
byte MDIChildProc#,112 = $74
byte MDIChildProc#,113 = $39

'cmp dword ptr [ebp+0Ch],00000003h (WM_MOVE)
byte MDIChildProc#,114 = $81
byte MDIChildProc#,115 = $7D
byte MDIChildProc#,116 = $0C
long MDIChildProc#,117 = $00000003
'je MDIChildProc# + 188
byte MDIChildProc#,121 = $74
byte MDIChildProc#,122 = $49
'cmp dword ptr [ebp+0Ch],00000005h (WM_SIZE)
byte MDIChildProc#,123 = $81
byte MDIChildProc#,124 = $7D
byte MDIChildProc#,125 = $0C
long MDIChildProc#,126 = $00000005
'je MDIChildProc# + 188
byte MDIChildProc#,130 = $74
byte MDIChildProc#,131 = $40

'---Start Original-Fensterprozedur aufrufen:
'mov edx,dword ptr [ebp+14h]
byte MDIChildProc#,132 = $8B
byte MDIChildProc#,133 = $55
byte MDIChildProc#,134 = $14
'push edx
byte MDIChildProc#,135 = $52
'mov eax,dword ptr [ebp+10h]
byte MDIChildProc#,136 = $8B
byte MDIChildProc#,137 = $45
byte MDIChildProc#,138 = $10
'push eax
byte MDIChildProc#,139 = $50
'mov ecx,dword ptr [ebp+0Ch]
byte MDIChildProc#,140 = $8B
byte MDIChildProc#,141 = $4D
byte MDIChildProc#,142 = $0C
'push ecx
byte MDIChildProc#,143 = $51
'mov edx,dword ptr [ebp+08h]
byte MDIChildProc#,144 = $8B
byte MDIChildProc#,145 = $55
byte MDIChildProc#,146 = $08
'push edx
byte MDIChildProc#,147 = $52
'push -00000015
byte MDIChildProc#,148 = $6A
byte MDIChildProc#,149 = $EB
'mov ecx,dword ptr [ebp+08h]
byte MDIChildProc#,150 = $8B
byte MDIChildProc#,151 = $4D
byte MDIChildProc#,152 = $08
'push ecx
byte MDIChildProc#,153 = $51
'mov edx,USER32.GetWindowLongA
string modName#,0 = "USER32"
string procName#,0 = "GetWindowLongA"
let procAddress& = GetProcAddress(GetModuleHandle(modName#),procName#)

byte MDIChildProc#,154 = $BA
long MDIChildProc#,155 = procAddress&
'call FAR edx
byte MDIChildProc#,159 = $FF
byte MDIChildProc#,160 = $D2
'push eax
byte MDIChildProc#,161 = $50
'mov edx,USER32.CallWindowProcA
string modName#,0 = "USER32"
string procName#,0 = "CallWindowProcA"
let procAddress& = GetProcAddress(GetModuleHandle(modName#),procName#)

byte MDIChildProc#,162 = $BA
long MDIChildProc#,163 = procAddress&
'call FAR edx
byte MDIChildProc#,167 = $FF
byte MDIChildProc#,168 = $D2
'---Ende Original-Fensterprozedur aufrufen.

'jmp MDIChildProc# + 256
byte MDIChildProc#,169 = $EB
byte MDIChildProc#,170 = $55

'---Start DefMDIChildProc aufrufen:
'mov ecx,dword ptr [ebp+14h]
byte MDIChildProc#,171 = $8B
byte MDIChildProc#,172 = $4D
byte MDIChildProc#,173 = $14
'push ecx
byte MDIChildProc#,174 = $51
'mov edx,dword ptr [ebp+10h]
byte MDIChildProc#,175 = $8B
byte MDIChildProc#,176 = $55
byte MDIChildProc#,177 = $10
'push edx
byte MDIChildProc#,178 = $52
'mov eax,dword ptr [ebp+0Ch]
byte MDIChildProc#,179 = $8B
byte MDIChildProc#,180 = $45
byte MDIChildProc#,181 = $0C
'push eax
byte MDIChildProc#,182 = $50
'mov ecx,dword ptr [ebp+08h]
byte MDIChildProc#,183 = $8B
byte MDIChildProc#,184 = $4D
byte MDIChildProc#,185 = $08
'push ecx
byte MDIChildProc#,186 = $51
'mov edx,USER32.DefMDIChildProcA
string modName#,0 = "USER32"
string procName#,0 = "DefMDIChildProcA"
let procAddress& = GetProcAddress(GetModuleHandle(modName#),procName#)

byte MDIChildProc#,187 = $BA
long MDIChildProc#,188 = procAddress&
'call FAR edx
byte MDIChildProc#,192 = $FF
byte MDIChildProc#,193 = $D2
'---Ende DefMDIChildProc aufrufen.

'jmp MDIChildProc# + 256
byte MDIChildProc#,194 = $EB
byte MDIChildProc#,195 = $3C

'---Start Original-Fensterprozedur und DefMDIChildProc aufrufen:
'mov edx,dword ptr [ebp+14h]
byte MDIChildProc#,196 = $8B
byte MDIChildProc#,197 = $55
byte MDIChildProc#,198 = $14
'push edx
byte MDIChildProc#,199 = $52
'mov eax,dword ptr [ebp+10h]
byte MDIChildProc#,200 = $8B
byte MDIChildProc#,201 = $45
byte MDIChildProc#,202 = $10
'push eax
byte MDIChildProc#,203 = $50
'mov ecx,dword ptr [ebp+0Ch]
byte MDIChildProc#,204 = $8B
byte MDIChildProc#,205 = $4D
byte MDIChildProc#,206 = $0C
'push ecx
byte MDIChildProc#,207 = $51
'mov edx,dword ptr [ebp+08h]
byte MDIChildProc#,208 = $8B
byte MDIChildProc#,209 = $55
byte MDIChildProc#,210 = $08
'push edx
byte MDIChildProc#,211 = $52
'push -00000015
byte MDIChildProc#,212 = $6A
byte MDIChildProc#,213 = $EB
'mov ecx,dword ptr [ebp+08h]
byte MDIChildProc#,214 = $8B
byte MDIChildProc#,215 = $4D
byte MDIChildProc#,216 = $08
'push ecx
byte MDIChildProc#,217 = $51
'mov edx,USER32.GetWindowLongA
string modName#,0 = "USER32"
string procName#,0 = "GetWindowLongA"
let procAddress& = GetProcAddress(GetModuleHandle(modName#),procName#)

byte MDIChildProc#,218 = $BA
long MDIChildProc#,219 = procAddress&
'call FAR edx
byte MDIChildProc#,223 = $FF
byte MDIChildProc#,224 = $D2
'push eax
byte MDIChildProc#,225 = $50
'mov edx,USER32.CallWindowProcA
string modName#,0 = "USER32"
string procName#,0 = "CallWindowProcA"
let procAddress& = GetProcAddress(GetModuleHandle(modName#),procName#)

byte MDIChildProc#,226 = $BA
long MDIChildProc#,227 = procAddress&
'call FAR edx
byte MDIChildProc#,231 = $FF
byte MDIChildProc#,232 = $D2
'-------------------------------
'mov ecx,dword ptr [ebp+14h]
byte MDIChildProc#,233 = $8B
byte MDIChildProc#,234 = $4D
byte MDIChildProc#,235 = $14
'push ecx
byte MDIChildProc#,236 = $51
'mov edx,dword ptr [ebp+10h]
byte MDIChildProc#,237 = $8B
byte MDIChildProc#,238 = $55
byte MDIChildProc#,239 = $10
'push edx
byte MDIChildProc#,240 = $52
'mov eax,dword ptr [ebp+0Ch]
byte MDIChildProc#,241 = $8B
byte MDIChildProc#,242 = $45
byte MDIChildProc#,243 = $0C
'push eax
byte MDIChildProc#,244 = $50
'mov ecx,dword ptr [ebp+08h]
byte MDIChildProc#,245 = $8B
byte MDIChildProc#,246 = $4D
byte MDIChildProc#,247 = $08
'push ecx
byte MDIChildProc#,248 = $51
'mov edx,USER32.DefMDIChildProcA
string modName#,0 = "USER32"
string procName#,0 = "DefMDIChildProcA"
let procAddress& = GetProcAddress(GetModuleHandle(modName#),procName#)

byte MDIChildProc#,249 = $BA
long MDIChildProc#,250 = procAddress&
'call FAR edx
byte MDIChildProc#,254 = $FF
byte MDIChildProc#,255 = $D2
'---Ende Original-Fensterprozedur und DefMDIChildProc aufrufen.

'pop ebp
byte MDIChildProc#,256 = $5D
'ret 10h
byte MDIChildProc#,257 = $C2
byte MDIChildProc#,258 = $10
byte MDIChildProc#,259 = $00

dispose modName#
dispose procName#
